#!/usr/bin/env python
#-*- coding: ISO-8859-1 -*-
#
# Author: Brian Bockelman

import time
import ConfigParser

from FileManager import Server


def makeConfigParser():
    cp = ConfigParser.ConfigParser()
    cp.add_section("file_manager")
    cp.set("file_manager", "base_directory", "/Users/brian/tmp/cms_stuff")
    cp.add_section("transfer_wrapper")
    cp.set("transfer_wrapper", "transfer_command", "srmcp -debug=true -srm_protocol_version=2 -retry_num=1 -streams_num=1")
    return cp

if __name__ == '__main__':
    # Test case demonstrates:
    # - Single transfer works
    # - Second transfer starts up in parallel
    # - Third transfer notices that it's for the same LFN as the first, and it
    #   just sits waiting for the first one to finish.
    # - Cancelling works
    # - Graceful shutdown works
    cp = makeConfigParser()
    Server.configure(cp)
    Server.request("/store/data/CRUZET2/Cosmics/RECO/CRUZET2_V1_v2/0018/FEB27E49-B63C-DD11-89D8-000423D6B42C.root")
    time.sleep(10)
    Server.request("/store/data/CRUZET2/Cosmics/RECO/CRUZET2_V1_v2/0018/FEB27E49-B63C-DD11-89D8-000423D6B42C.root")
    Server.request("/store/data/CRUZET2/Cosmics/RECO/CRUZET2_V1_v2/0018/FE989CBF-913C-DD11-BEE5-001617E30CE8.root")
    time.sleep(5)
    print "****", Server.status("/store/data/CRUZET2/Cosmics/RECO/CRUZET2_V1_v2/0018/FE989CBF-913C-DD11-BEE5-001617E30CE8.root")
    print "****", Server.status("/store/data/CRUZET2/Cosmics/RECO/CRUZET2_V1_v2/0018/FEB27E49-B63C-DD11-89D8-000423D6B42C.root")
    time.sleep(30)
    Server.cancel("/store/data/CRUZET2/Cosmics/RECO/CRUZET2_V1_v2/0018/FE989CBF-913C-DD11-BEE5-001617E30CE8.root")
    # Note that the thread pool is all daemon - if the main thread exits, the
    # python process terminates, even if the thread pool is running.  Hence, we
    # use the graceful_exit function
    Server.graceful_exit()

    # At this point, you can hit Ctrl+C, and the partial file will clean up
    # and the transfer will kill itself.

    # Let this run successfully once, and notice that if you run it again,
    # the file was cached locally and the request returns successfully
    # instantly.
